﻿using Syncfusion.Windows.Forms;
using Syncfusion.Windows.Forms.Tools;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace TreeViewAdv_Tristate
{
    public partial class Form1 : MetroForm
    {
        public Form1()
        {
            InitializeComponent();
            this.treeViewAdv1.Style = Syncfusion.Windows.Forms.Tools.TreeStyle.Default;
            this.treeViewAdv1.InteractiveCheckBoxes = true;
        }

        private void UpdateAllNodes()
        {
            TreeViewAdv myTree = this.treeViewAdv1;

            var allNodes = myTree.Nodes
                .Cast<TreeNodeAdv>()
                .SelectMany(GetNodeBranch);

            foreach (TreeNodeAdv treeNode in allNodes)
            {
                treeNode.IntermediateCheckColor = Color.Black;
                treeNode.IntermediateCheckBoxBackGround = Brushes.Black;
            }
        }

        private IEnumerable<TreeNodeAdv> GetNodeBranch(TreeNodeAdv node)
        {
            yield return node;

            foreach (TreeNodeAdv child in node.Nodes)
                foreach (var childChild in GetNodeBranch(child))
                    yield return childChild;
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            UpdateAllNodes();
        }
    }
}
